import java.awt.*; 
import java.awt.image.*; 
import java.io.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 

import Acme.JPM.Encoders.*; 

public class ShrinkFilterServlet extends HttpServlet { 

 public void doGet(HttpServletRequest req, HttpServletResponse res) 
 										throws ServletException, IOException { 
 
  ServletOutputStream out = res.getOutputStream(); 

  String contType = req.getContentType(); 
  if (contType == null || !contType.startsWith("image")) { 
     throw new ServletException("Chba content type, mus by \"image/*\""); 
  } 

  // zskame dta obsahujce obrzok 
  DataInputStream in = new DataInputStream(new BufferedInputStream(req.getInputStream())); 
  ByteArrayOutputStream baos = new ByteArrayOutputStream(); 
  byte[] buf = new byte[4 * 1024]; // 4K buffer 
  int len; 
  while ((len = in.read(buf, 0, buf.length)) != -1) { 
   baos.write(buf, 0, len); 
  } 

  // vytvorme objekt image 
  Image image = Toolkit.getDefaultToolkit().createImage(baos.toByteArray()); 

  // vytvorme ale nezobrazme frame 
  Frame frame = new Frame(); 

  // natiahneme obrzok a zskame jeho vku a rku 
  MediaTracker mt = new MediaTracker(frame); 
  mt.addImage(image, 0); 
  try { 
   mt.waitForAll(); 
  } 
  catch (InterruptedException e) { 
   getServletContext().log("Chyba pri natan obrzka.", e); 
   throw new ServletException(e.getMessage()); 
  } 

  /* Zmenme rozmery obrzku na polovicu. 
  Vylepen verzia servletu by mohla zska 
  poadovan pomer strn z inicializanch parametrov. 
  Ako alternatvu by sme mohli vyui triedu 
  java.awt.image.AreaAveragingScaleFilter, alebo triedu 
  java.awt.image.ReplicateScaleFilter. */ 
  Image shrunk = image.getScaledInstance(image.getWidth(frame) / 2, image.getHeight(frame) / 2, image.SCALE_DEFAULT); 

  // zmenen obrzok zakdujeme a poleme 
  res.setContentType("image/gif"); 
  GifEncoder encoder = new GifEncoder(shrunk, out); 
  encoder.encode(); 
 } 
}